/*
Tale classe rappresenta un builder generico.
Essa è astratta perchè dovrà essere specializzata.
*/
abstract public class Builder{
	//memorizzo il prodotto vero e proprio
	protected Product prodotto;

	//metodo per ottenere il prodotto
	public Product getProduct(){
		return prodotto;
	}

	//metodo per instanziare il prodotto (assumerebbe i valori di default)
	public void createNewProduct(){
		prodotto=new Product();
	}

	//metodi astratti che le sottoclassi dovranno implementare per 
	//permettere la costruzione delle varie parti del prodotto.
	public abstract void buildA();
	//....
	public abstract void buildZ();
}