/*
tale classe ha il compito di costruire un prodotto in base al "costruttore" (builder)
che gli è stato assegnato.
A tale classe non cambia niente sapere quale tipo di prodotto andrà a costruire,
l'unica cosa che dovrà conoscere sarà il suo builder.
*/
public class Director{
	//rappresenta il builder da utilizzare
	private Builder builder;

	//metodo per restituire il prodotto una volta costruito
	public Product getProduct(){
		return builder.getProduct();
	}

	//metodo per impostare quale builder utilizzare per la costruzione del prodotto
	public void setBuilder(Builder b){
		builder=b;
	}

	//metodo per avviare la costruzione del prodotto
	public void costructProduct(){
		//viene creato il prodotto
		builder.createNewProduct();

		//vegono costruite le varie parti del prodotto
		builder.buildA();
		//...
		builder.buildZ();
	}
}